<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/meshsel.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/meshsel.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PF_MESHSEL__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_MESHSEL__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00027"></a>00027 <span class="keyword">struct </span><a class="code" href="structiPcCamera.html" title="The representation of a camera.">iPcCamera</a>;
<a name="l00028"></a>00028 <span class="keyword">struct </span><a class="code" href="structiPcMovable.html" title="Control moving an iPcMesh.">iPcMovable</a>;
<a name="l00029"></a>00029 <span class="keyword">struct </span><a class="code" href="structiPcMesh.html" title="This is a property class holding the representation of a mesh.">iPcMesh</a>;
<a name="l00030"></a>00030 <span class="keyword">struct </span><a class="code" href="structiPcMeshSelect.html" title="This is a property class for selecting meshes.">iPcMeshSelect</a>;
<a name="l00031"></a>00031 <span class="keyword">class </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#define CEL_MOUSE_BUTTON1 1</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="preprocessor">#define CEL_MOUSE_BUTTON2 2</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#define CEL_MOUSE_BUTTON3 4</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00040"></a><a class="code" href="structiPcMeshSelectListener.html">00040</a> <span class="keyword">struct </span><a class="code" href="structiPcMeshSelectListener.html" title="Listen to mesh selection.">iPcMeshSelectListener</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   SCF_INTERFACE (<a class="code" href="structiPcMeshSelectListener.html" title="Listen to mesh selection.">iPcMeshSelectListener</a>, 0, 0, 1);
<a name="l00043"></a>00043 
<a name="l00047"></a>00047   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelectListener.html#a2723b51fcbbf80efad7affef0df15ac4" title="Mouse button goes down on mesh.">MouseDown</a> (<a class="code" href="structiPcMeshSelect.html" title="This is a property class for selecting meshes.">iPcMeshSelect</a>* meshsel,
<a name="l00048"></a>00048         <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y, <span class="keywordtype">int</span> button, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00049"></a>00049 
<a name="l00053"></a>00053   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelectListener.html#a2586b2f004053f2e6108fadce4cc3106" title="Mouse button goes up on mesh.">MouseUp</a> (<a class="code" href="structiPcMeshSelect.html" title="This is a property class for selecting meshes.">iPcMeshSelect</a>* meshsel,
<a name="l00054"></a>00054         <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y, <span class="keywordtype">int</span> button, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00055"></a>00055 
<a name="l00059"></a>00059   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelectListener.html#a7e1647fd1113f50dd9f88f37a275a32e" title="Mouse moves while mesh is selected.">MouseMove</a> (<a class="code" href="structiPcMeshSelect.html" title="This is a property class for selecting meshes.">iPcMeshSelect</a>* meshsel,
<a name="l00060"></a>00060         <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y, <span class="keywordtype">int</span> button, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00061"></a>00061 };
<a name="l00062"></a>00062 
<a name="l00089"></a><a class="code" href="structiPcMeshSelect.html">00089</a> <span class="keyword">struct </span><a class="code" href="structiPcMeshSelect.html" title="This is a property class for selecting meshes.">iPcMeshSelect</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00090"></a>00090 {
<a name="l00091"></a>00091   SCF_INTERFACE (<a class="code" href="structiPcMeshSelect.html" title="This is a property class for selecting meshes.">iPcMeshSelect</a>, 0, 0, 2);
<a name="l00092"></a>00092 
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a003a8c1980e045a03c11dcc51a3201e2" title="Add a listener to listen to mouse selection.">AddMeshSelectListener</a> (<a class="code" href="structiPcMeshSelectListener.html" title="Listen to mesh selection.">iPcMeshSelectListener</a>* listener) = 0;
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a506b74d5aa4840565b87250e0950b3bd" title="Remove a mesh selection listener.">RemoveMeshSelectListener</a> (<a class="code" href="structiPcMeshSelectListener.html" title="Listen to mesh selection.">iPcMeshSelectListener</a>* listener) = 0;
<a name="l00102"></a>00102 
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a3851251af34515ce15b4e8e7ca0a0a9e" title="Set the camera to use for mesh selection.">SetCamera</a> (<a class="code" href="structiPcCamera.html" title="The representation of a camera.">iPcCamera</a>* camera) = 0;
<a name="l00107"></a>00107 
<a name="l00113"></a>00113   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a06a14ad288a68cc4b87519540e0514ac" title="Indicate (with a bit-mask) for which buttons this mesh selector will work.">SetMouseButtons</a> (<span class="keywordtype">int</span> buttons) = 0;
<a name="l00114"></a>00114 
<a name="l00120"></a>00120   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a06a14ad288a68cc4b87519540e0514ac" title="Indicate (with a bit-mask) for which buttons this mesh selector will work.">SetMouseButtons</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* buttons) = 0;
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="structiPcMeshSelect.html#aa8f6be714ce22d723e7718deab7d1a9f" title="Get the bit-mask for the supported buttons.">GetMouseButtons</a> () <span class="keyword">const</span> = 0;
<a name="l00125"></a>00125 
<a name="l00133"></a>00133   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a5839931c030d52b65922f0927afbe24d" title="Set global/local selection.">SetGlobalSelection</a> (<span class="keywordtype">bool</span> glob) = 0;
<a name="l00137"></a>00137   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcMeshSelect.html#a5c36f2830df3af7f88b6954afb0e8d96" title="Get value of global/local selection.">HasGlobalSelection</a> () <span class="keyword">const</span> = 0;
<a name="l00138"></a>00138 
<a name="l00147"></a>00147   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a02fa1e98f777b0be713769f88bf39d8e" title="If true then follow the mouse so that up/down events come through immediatelly when the mouse leaves ...">SetFollowMode</a> (<span class="keywordtype">bool</span> follow) = 0;
<a name="l00151"></a>00151   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcMeshSelect.html#a81e324a5cff0ebd3fb18573cf812d298" title="Get the value of follow mode.">HasFollowMode</a> () <span class="keyword">const</span> = 0;
<a name="l00152"></a>00152 
<a name="l00158"></a>00158   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#aa5cc6a32f28004b105c667ade955a609" title="If true then also send move messages when the entity is not selected but the mouse is positioned on t...">SetFollowAlwaysMode</a> (<span class="keywordtype">bool</span> followalways) = 0;
<a name="l00162"></a>00162   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcMeshSelect.html#a3a9ba9328a5e0f359ee30160ef1cd97a" title="Get the value of follow always mode.">HasFollowAlwaysMode</a> () <span class="keyword">const</span> = 0;
<a name="l00163"></a>00163 
<a name="l00170"></a>00170   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a38b1b6bafad0d62d0123dafb1020e3cc" title="If true then it is possible to drag the selected object.">SetDragMode</a> (<span class="keywordtype">bool</span> drag) = 0;
<a name="l00174"></a>00174   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcMeshSelect.html#aec066bb5a01a2ba88c8e52a7fef3561a" title="Get value of drag mode.">HasDragMode</a> () <span class="keyword">const</span> = 0;
<a name="l00175"></a>00175 
<a name="l00185"></a>00185   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a8641509a8eb0ec284432408da301201e" title="Set the normal of the plane on which the dragged object will move.">SetDragPlaneNormal</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; drag_normal,
<a name="l00186"></a>00186         <span class="keywordtype">bool</span> camera_space) = 0;
<a name="l00190"></a>00190   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#afe57fc169f00bd7b637040caee8029e3" title="Get the drag normal and camera space flag.">GetDragPlaneNormal</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; drag_normal,
<a name="l00191"></a>00191         <span class="keywordtype">bool</span>&amp; camera_space) <span class="keyword">const</span> = 0;
<a name="l00192"></a>00192 
<a name="l00198"></a>00198   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a6fee341f0bd1c14877587d28cf3cbbf1" title="If true then also send messages on mouse move (only between mouse-down and mouse-up (message &#39;selectm...">SetSendmoveEvent</a> (<span class="keywordtype">bool</span> mov) = 0;
<a name="l00202"></a>00202   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcMeshSelect.html#a50fa2c873d138e4cf121a5c6748a7918" title="Get the value of send move events.">HasSendmoveEvent</a> () <span class="keyword">const</span> = 0;
<a name="l00203"></a>00203 
<a name="l00208"></a>00208   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a1c3a615b4d567a95823cdf453fbaf318" title="If true then send mouse-up events (message &#39;selectmesh_up&#39;).">SetSendupEvent</a> (<span class="keywordtype">bool</span> su) = 0;
<a name="l00212"></a>00212   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcMeshSelect.html#a2e5ff3f6d29e8e23293b52c7792ac38d" title="Get the value of send up events.">HasSendupEvent</a> () <span class="keyword">const</span> = 0;
<a name="l00213"></a>00213 
<a name="l00218"></a>00218   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#a5f20d1fcdc70c5db28549bbfa48a838c" title="If true then send mouse-down events (message &#39;selectmesh_down&#39;).">SetSenddownEvent</a> (<span class="keywordtype">bool</span> sd) = 0;
<a name="l00222"></a>00222   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcMeshSelect.html#a7e0a7edf84513530c8a412087f89c5f7" title="Get the value of send down events.">HasSenddownEvent</a> () <span class="keyword">const</span> = 0;
<a name="l00223"></a>00223 
<a name="l00228"></a>00228   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcMeshSelect.html#ac3da18605c5c9281c7db370182579242" title="Set the maximum distance to use for mesh selection.">SetMaxSelectionDistance</a> (<span class="keywordtype">float</span> distance) = 0;
<a name="l00229"></a>00229 
<a name="l00233"></a>00233   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcMeshSelect.html#a68cce0df3e96c93f7d1cdd13b3aaf7f3" title="Get the maximum distance to use for mesh selection.">GetMaxSelectionDistance</a> () <span class="keyword">const</span> = 0;
<a name="l00234"></a>00234 };
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 <span class="preprocessor">#endif // __CEL_PF_MESHSEL__</span>
<a name="l00237"></a>00237 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
